---
schema_version: "1"
id: 16c1cc938064d46aa6bf1a3c70ca12c42251dd8d040d12692b82bba1c6796450
title: TMF648 v4 Customer Quote Management
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/industries-integrations/comms/references/generated-api-specs/tmf648.md
canonical_url: https://developer.salesforce.com/docs/industries/communications/references/tmf648
source_site: developer.salesforce.com
content_type: documentation
content_hash: 4b2de48a1c166b13858710f16b1d6387e50594f22d66fd3c7447c128413a0f77
products:
  - Communications Cloud TM Forum API
  - Industries Integrations
---
TMF648 v4 Customer Quote Management

# TMF648 v4 Customer Quote Management

Use the Quote Management API to create a customer quote as well as to retrieve a customer quote depending on filter criteria.

**Version:** v1

Protocols: https.

## Operations

### GET List quotes

`GET /quote`

Retrieves a Quote entity. Attribute selection is enabled for first-level attributes.

#### Parameters

*   `fields` (query, string) Specifies the comma-separated properties to be included in the response. supported fields are category, description, state, quoteDate
*   `offset` (query, integer) Specifies the requested index for the start of the resources to be included in the response.
*   `limit` (query, integer) Specifies the requested number of the resources to be included in the response.
*   `category` (query, string) Filtering based on category. Category is used to categorize the quote from a business perspective that can be useful for the CRM system (e.g. "enterprise", "residential", ...).
*   `state` (query, string) Filtering based on state. state is a quote state type (QuoteStateType). State of the quote described in the state-machine diagram.
*   `quoteDate` (query, datetime) Filtering based on quoteDate. quoteDate is a date time (DateTime). Date and time when the quote was created.
*   `Authorization` (header, string, required) Specifies the bearer token to use for the authentication of request.
*   `Namespace` (header, string) Specifies the namespace to use with the URL path.
*   `Domain-Name` (header, string, required) Specifies the domain name to use with the URL path received from the userinfo API.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `array of Quote_retrieve`.
    
    Array of `Quote_retrieve`.
    
    _Example_
    
    ```
    [
      {
        "category": "Existing Customer - Upgrade",
        "description": "TMF648 testing 1",
        "id": "00001204",
        "quoteDate": "2023-09-13T03:46:02Z",
        "state": "Draft",
        "agreement": [
            {
                "id": "00000945",
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Contract/00000945"
            }
        ],
        "billingAccount": [
            {
                "id": "CD123",
                "name": "Acme",
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/CD123"
            }
        ],
        "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/quote/00001204",
        "version": "V1",
        "relatedParty": [
            {
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/1234",
                "id": "1234",
                "name": "Common Org Account",
                "role": "Account",
                "@referredType": "Account"
            },
            {
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Contact/003Do00000PSgbhIAD",
                "id": "003Do00000PSgbhIAD",
                "name": "common",
                "role": "Contact",
                "@referredType": "Contact"
            }
        ],
        "contactMedium": [
            {
                "mediumType": "Email",
                "characteristic": {
                    "contactType": "Email",
                    "emailAddress": "abc@salesforce.com"
                }
            },
            {
                "mediumType": "Phone",
                "characteristic": {
                    "contactType": "Phone",
                    "phoneNumber": "(990) 099-7788"
                }
            },
            {
                "mediumType": "Fax",
                "characteristic": {
                    "contactType": "Fax",
                    "faxNumber": "abc"
                }
            }
        ],
      "quoteTotalPrice": [
          {
              "price": {
                  "taxIncludedAmount": {
                      "unit" : "\$",
                      "value": 10.00
                  }
              },
              "priceType": "Recurring"
          },
          {
              "price": {
                  "taxIncludedAmount": {
                      "unit" : "\$",
                      "value": 0.00
                  }
              },
              "priceType": "One-time"
          }
        ],
      "quoteItem": [
        {
          "id": "00001933",
          "action": "Add",
          "quantity": 1.00,
          "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/QuoteLineItem/00001933",
          "relatedParty": [
              {
                  "id": "001Dp00000JGwiTIAT",
                  "name": "Test Account",
                  "role": "Service Account",
                  "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/001Dp00000JGwiTIAT",
                  "@referredType": "Account"
              }
          ],
          "productOffering": [
              {
                  "id": "686c69b9-9def-2dc2-4f69-11141e9f92c5",
                  "name": "TMF648 Product",
                  "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Product2/686c69b9-9def-2dc2-4f69-11141e9f92c5",
                  "@type": "Product2"
              }
          ]
        }
      ]
      },
      {
        "category": "Existing Customer - Downgrade",
        "description": "TMF648 testing",
        "id": "00001205",
        "quoteDate": "2023-09-13T03:46:20Z",
        "state": "In Review",
        "agreement": [
            {
                "id": "00000944",
                "name": "TMForum",
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Contract/00000944"
            }
        ],
        "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/quote/00001205",
        "version": "V1",
        "contactMedium": [
            {
                "mediumType": "Email",
                "characteristic": {
                    "contactType": "Email",
                    "emailAddress": "abc@salesforce.com"
                }
            },
            {
                "mediumType": "Phone",
                "characteristic": {
                    "contactType": "Phone",
                    "phoneNumber": "(887) 788-5566"
                }
            },
            {
                "mediumType": "Fax",
                "characteristic": {
                    "contactType": "Fax",
                    "faxNumber": "xyz"
                }
            }
        ],
        "quoteTotalPrice": [
        {
            "price": {
                "taxIncludedAmount": {
                    "unit" : "\$",
                    "value": 10.00
                }
            },
            "priceType": "Recurring"
        },
        {
            "price": {
                "taxIncludedAmount": {
                    "unit" : "\$",
                    "value": 0.00
                }
            },
            "priceType": "One-time"
        }
      ],
      "quoteItem": [
        {
          "id": "00001933",
          "action": "Add",
          "quantity": 1.00,
          "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/QuoteLineItem/00001933",
          "relatedParty": [
              {
                  "id": "001Dp00000JGwiTIAT",
                  "name": "Test Account",
                  "role": "Service Account",
                  "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/001Dp00000JGwiTIAT",
                  "@referredType": "Account"
              }
          ],
          "productOffering": [
              {
                  "id": "686c69b9-9def-2dc2-4f69-11141e9f92c5",
                  "name": "TMF648 Product",
                  "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Product2/686c69b9-9def-2dc2-4f69-11141e9f92c5",
                  "@type": "Product2"
              }
          ]
        }
      ]
      },
      {
        "category": "New Customer",
        "description": "TMF648 Testing 3",
        "id": "00001206",
        "quoteDate": "2023-09-13T03:46:35Z",
        "state": "Accepted",
        "agreement": [
            {
                "id": "00000944",
                "name": "TMForum",
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Contract/00000944"
            }
        ],
        "billingAccount": [
            {
                "id": "CD123",
                "name": "Acme",
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/CD123"
            }
        ],
        "quoteTotalPrice": [
          {
              "price": {
                  "taxIncludedAmount": {
                      "unit" : "\$",
                      "value": 10.00
                  }
              },
              "priceType": "Recurring"
          },
          {
              "price": {
                  "taxIncludedAmount": {
                      "unit" : "\$",
                      "value": 0.00
                  }
              },
              "priceType": "One-time"
          }
        ],
        "effectiveQuoteCompletionDate": "2023-09-19T13:58:29Z",
        "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/quote/00001206",
        "version": "V1",
        "relatedParty": [
            {
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/1234",
                "id": "1234",
                "name": "Common Org Account",
                "role": "Account",
                "@referredType": "Account"
            },
            {
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Contact/003Do00000PSgbhIAD",
                "id": "003Do00000PSgbhIAD",
                "name": "common",
                "role": "Contact",
                "@referredType": "Contact"
            }
        ],
        "quoteItem": [
          {
            "id": "00001933",
            "action": "Add",
            "quantity": 1.00,
            "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/QuoteLineItem/00001933",
            "relatedParty": [
                {
                    "id": "001Dp00000JGwiTIAT",
                    "name": "Test Account",
                    "role": "Service Account",
                    "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/001Dp00000JGwiTIAT",
                    "@referredType": "Account"
                }
            ],
            "productOffering": [
                {
                    "id": "686c69b9-9def-2dc2-4f69-11141e9f92c5",
                    "name": "TMF648 Product",
                    "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Product2/686c69b9-9def-2dc2-4f69-11141e9f92c5",
                    "@type": "Product2"
                }
            ]
          }
        ],
        "contactMedium": [
          {
              "mediumType": "Email",
              "characteristic": {
                  "contactType": "Email",
                  "emailAddress": "xyz@salesforce.com"
              }
          },
          {
              "mediumType": "Phone",
              "characteristic": {
                  "contactType": "Phone",
                  "phoneNumber": "(999) 222-8881"
              }
          },
          {
              "mediumType": "Fax",
              "characteristic": {
                  "contactType": "Fax",
                  "faxNumber": "xyz"
              }
          }
        ]
      }
    ]
    ```
    
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: NOT_FOUND
    reason: There are no matching resource.
    ```
    
*   **500** Unable to complete the request as the server encountered an error.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "500"
    reason: Internal Server Error
    ```
    

### POST Create a quote

`POST /quote`

Creates a Quote entity.

#### Parameters

*   `Authorization` (header, string, required) Specifies the bearer token to use for the authentication of request.
*   `Namespace` (header, string) Specifies the namespace to use with the URL path.
*   `Domain-Name` (header, string, required) Specifies the domain name to use with the URL path received from the userinfo API.

#### Request body

Media type: `application/json`. Schema: `Quote_create`.

Specifies the Quote to be created.

_Example_

```
{
    "description": "TMF648",
    "category": "New Customer",
    "agreement": [
        {
            "id": "00000100"
        }
    ],
    "contactMedium": [
        {
            "mediumType": "Email",
            "characteristic": {
                "contactType": "Email",
                "emailAddress": "abc@salesforce.com"
            }
        },
        {
            "mediumType": "Phone",
            "characteristic": {
                "contactType": "Phone",
                "phoneNumber": "(990) 099-7788"
            }
        },
        {
            "mediumType": "Fax",
            "characteristic": {
                "contactType": "Fax",
                "faxNumber": "abc"
            }
        }
    ],
    "billingAccount": [
        {
            "id": "CD451791"
        }
    ],
    "relatedParty": [
        {
            "id": "CD3344",
            "role": "Account",
            "@referredType": "Account"
        },
        {
            "id": "003Dp000007ElkNIAS",
            "role": "Contact",
            "@referredType": "Contact"
        }
    ],
    "quoteItem": [
        {
            "quantity": 1,
            "action": "add",
            "productOffering": [
                {
                    "id": "686c69b9-9def-2dc2-4f69-11141e9f92c5",
                    "name": "TMF648 Product",
                    "@type": "Product2"
                }
            ]
        }
    ]
}
```

#### Responses

*   **201** Created the resource.
    
    Media type: `application/json`. Schema: `Quote_create_response`.
    
    _Example_
    
    ```
    {
        "contactMedium": [
            {
                "characteristic": {
                    "contactType": "Email",
                    "emailAddress": "abc@salesforce.com"
                },
                "mediumType": "Email"
            },
            {
                "characteristic": {
                    "contactType": "Phone",
                    "phoneNumber": "(990) 099-7788"
                },
                "mediumType": "Phone"
            },
            {
                "characteristic": {
                    "contactType": "Fax",
                    "faxNumber": "abc"
                },
                "mediumType": "Fax"
            }
        ],
        "quoteItem": [
            {
                "productOffering": [
                    {
                        "@type": "Product2",
                        "name": "TMF648 Product",
                        "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Product2/686c69b9-9def-2dc2-4f69-11141e9f92c5",
                        "id": "686c69b9-9def-2dc2-4f69-11141e9f92c5"
                    }
                ],
                "relatedParty": [
                    {
                        "@referredType": "Account",
                        "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/001Dp00000JGwiTIAT",
                        "role": "Service Account",
                        "name": "Test Account",
                        "id": "001Dp00000JGwiTIAT"
                    }
                ],
                "quantity": 1.00,
                "action": "Add",
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/QuoteLineItem/00001933",
                "id": "00001933"
            }
        ],
        "quoteTotalPrice": [
            {
                "price": {
                    "taxIncludedAmount": {
                        "unit" : "\$",
                        "value": 10.00
                    }
                },
                "priceType": "Recurring"
            },
            {
                "price": {
                    "taxIncludedAmount": {
                        "unit" : "\$",
                        "value": 0.00
                    }
                },
                "priceType": "One-time"
            }
        ],
        "relatedParty": [
            {
                "@referredType": "Account",
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/CD3344",
                "role": "Account",
                "name": "Test Account",
                "id": "CD3344"
            },
            {
                "@referredType": "Contact",
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Contact/003Dp000007ElkNIAS",
                "role": "Contact",
                "name": "jgfhd kuyf",
                "id": "003Dp000007ElkNIAS"
            }
        ],
        "version": "V1",
        "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/quote/00003486",
        "billingAccount": [
            {
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/CD451791",
                "name": "Test Sh1",
                "id": "CD451791"
            }
        ],
        "agreement": [
            {
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Contract/00000100",
                "name": "TMForum",
                "id": "00000100"
            }
        ],
        "state": "Draft",
        "quoteDate": "2023-10-26T13:56:49Z",
        "category": "New Customer",
        "description": "TMF648",
        "id": "00003486"
    }
    ```
    
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "404"
    reason: State field should not be present in Payload
    ```
    
*   **500** Unable to complete the request as the server encountered an error.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "500"
    reason: Internal Server Error
    ```
    

### GET Retrieve a quote

`GET /quote/{id}`

Retrieves a Quote entity. Attribute selection is enabled for first-level attributes.

#### Parameters

*   `id` (path, string, required)
*   `fields` (query, string) Specifies the comma-separated properties to be included in the response. supported fields are category, description, state, quoteDate
*   `Authorization` (header, string, required) Specifies the bearer token to use for the authentication of request.
*   `Namespace` (header, string) Specifies the namespace to use with the URL path.
*   `Domain-Name` (header, string, required) Specifies the domain name to use with the URL path received from the userinfo API.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `Quote_retrieve`.
    
    _Example_
    
    ```
    {
        "id": "00003486",
        "description": "TMF648",
        "category": "New Customer",
        "quoteDate": "2023-10-26T13:56:49Z",
        "state": "Draft",
        "agreement": [
          {
            "id": "00000100",
            "name": "TMForum",
            "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Contract/00000100"
          }
        ],
        "billingAccount": [
          {
            "id": "CD451791",
            "name": "Test Sh1",
            "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/CD451791"
          }
        ],
        "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/quote/00003486",
        "version": "V1",
        "relatedParty": [
          {
            "id": "CD3344",
            "name": "Test Account",
            "role": "Account",
            "@referredType": "Account",
            "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/CD3344"
          },
          {
            "id": "003Dp000007ElkNIAS",
            "name": "jgfhd kuyf",
            "role": "Contact",
            "@referredType": "Contact",
            "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Contact/003Dp000007ElkNIAS"
          }
        ],
        "quoteTotalPrice": [
          {
            "price": {
              "taxIncludedAmount": {
                "unit": "\$",
                "value": 10.00
              }
            },
            "priceType": "Recurring"
          },
          {
            "price": {
              "taxIncludedAmount": {
                "unit": "\$",
                "value": 0.00
              }
            },
            "priceType": "One-time"
          }
        ],
        "quoteItem": [
          {
            "id": "00001933",
            "action": "Add",
            "quantity": 1.00,
            "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/QuoteLineItem/00001933",
            "relatedParty": [
              {
                "id": "001Dp00000JGwiTIAT",
                "name": "Test Account",
                "role": "Service Account",
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Account/001Dp00000JGwiTIAT",
                "@referredType": "Account"
              }
            ],
            "productOffering": [
              {
                "id": "686c69b9-9def-2dc2-4f69-11141e9f92c5",
                "name": "TMF648 Product",
                "href": "/services/apexrest/vlocity_cmt/tmforum/quotemanagement/v57.0/Product2/686c69b9-9def-2dc2-4f69-11141e9f92c5",
                "@type": "Product2"
              }
            ]
          }
        ],
        "contactMedium": [
          {
            "mediumType": "Email",
            "characteristic": {
              "emailAddress": "abc@salesforce.com",
              "contactType": "Email"
            }
          },
          {
            "mediumType": "Phone",
            "characteristic": {
              "phoneNumber": "(990) 099-7788",
              "contactType": "Phone"
            }
          },
          {
            "mediumType": "Fax",
            "characteristic": {
              "faxNumber": "abc",
              "contactType": "Fax"
            }
          }
        ]
      }
    ```
    
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: NOT_FOUND
    reason: There are no matching resource.
    ```
    
*   **500** Unable to complete the request as the server encountered an error.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "500"
    reason: Internal Server Error
    ```
    

## Schemas

### Quote\_retrieve

This object type is defined for retrieval of a quote - GET.

*   `id` (_string_, required) A string. Unique identifier - attributed by quoting system.
*   `href` (_string_) A string. Hyperlink to access the quote.
*   `category` (_string_) A string. Used to categorize the quote from a business perspective that can be useful for the CRM system (e.g. "enterprise", "residential", ...).
*   `description` (_string_) A string. Description of the quote.
*   `effectiveQuoteCompletionDate` (_datetime_) A date time (DateTime). Date when the quote has been completed.
*   `quoteDate` (_datetime_, required) A date time (DateTime). Date and time when the quote was created.
*   `version` (_string_) A string. Quote version - if the customer rejected the quote but negotiations still open a new version of the quote is managed.
*   `state` (_string_, required) A quote state type (QuoteStateType). State of the quote described in the state-machine diagram.
*   `agreement` (_array of object_) A list of agreement references (AgreementRef \[\*\]). A reference to an agreement defining the context of the quote.
    
    Includes all fields of `agreementRef`.
    
*   `billingAccount` (_array of object_) A list of billing account references (BillingAccountRef \[\*\]). A reference to a billing account to provide quote context information.
    
    Includes all fields of `billingAccount`.
    
*   `contactMedium` (_array of object_) A list of contact mediums (ContactMedium \[\*\]). Information contact related to the quote requester.
    
    Includes all fields of `contactMedium`.
    
*   `quoteItem` (_array of object_) A list of quote items (QuoteItem \[1..\*\]). An item of the quote - it is used to describe an operation on a product to be quoted.
    
    Includes all fields of `quoteItem`.
    
*   `quoteTotalPrice` (_array of object_, required) A list of quote prices (QuotePrice \[\*\]). Quote total price.
    
    Includes all fields of `quotePriceRef`.
    
*   `relatedParty` (_array of object_) A list of related parties (RelatedParty \[\*\]). A reference to a party playing a role in this quote (customer, seller, requester, etc.).
    
    Includes all fields of `relatedPartyRef`.
    

### Error

Shown when an API throws an error, typically with an HTTP error response code (3xx, 4xx, or 5xx).

*   `code` (_string_, required) Specifies the application-relevant detail defined in the API or a common list.
*   `reason` (_string_, required) Describes the reason for the error, which can be shown to a client user.

### Quote\_create

This object type is defined for creation of a quote - POST.

*   `category` (_string_) A string. Used to categorize the quote from a business perspective that can be useful for the CRM system (e.g. "enterprise", "residential", ...).
*   `description` (_string_) A string. Description of the quote.
*   `agreement` (_array of object_) A list of agreement references (AgreementRef \[\*\]). A reference to an agreement defining the context of the quote.
    
    Includes all fields of `agreementRef`.
    
*   `billingAccount` (_array of object_) A list of billing account references (BillingAccountRef \[\*\]). A reference to a billing account to provide quote context information.
    
    Includes all fields of `billingAccount`.
    
*   `contactMedium` (_array of object_) A list of contact mediums (ContactMedium \[\*\]). Information contact related to the quote requester.
    
    Includes all fields of `contactMedium`.
    
*   `quoteItem` (_array of object_, required) A list of quote items (QuoteItem \[1..\*\]). An item of the quote - it is used to describe an operation on a product to be quoted.
    
    Includes all fields of `quoteItem`.
    
*   `relatedParty` (_array of object_) A list of related parties (RelatedParty \[\*\]). A reference to a party playing a role in this quote (customer, seller, requester, etc.).
    
    Includes all fields of `relatedPartyRef`.
    

### Quote\_create\_response

This object type is defined for retrieval of a quote - GET.

*   `id` (_string_, required) A string. Unique identifier - attributed by quoting system.
*   `href` (_string_) A string. Hyperlink to access the quote.
*   `category` (_string_) A string. Used to categorize the quote from a business perspective that can be useful for the CRM system (e.g. "enterprise", "residential", ...).
*   `description` (_string_) A string. Description of the quote.
*   `effectiveQuoteCompletionDate` (_datetime_) A date time (DateTime). Date when the quote has been completed.
*   `quoteDate` (_datetime_, required) A date time (DateTime). Date and time when the quote was created.
*   `version` (_string_) A string. Quote version - if the customer rejected the quote but negotiations still open a new version of the quote is managed.
*   `state` (_string_, required) A quote state type (QuoteStateType). State of the quote described in the state-machine diagram.
*   `agreement` (_array of object_) A list of agreement references (AgreementRef \[\*\]). A reference to an agreement defining the context of the quote.
    
    Includes all fields of `agreementRef`.
    
*   `billingAccount` (_array of object_) A list of billing account references (BillingAccountRef \[\*\]). A reference to a billing account to provide quote context information.
    
    Includes all fields of `billingAccount`.
    
*   `contactMedium` (_array of object_) A list of contact mediums (ContactMedium \[\*\]). Information contact related to the quote requester.
    
    Includes all fields of `contactMedium`.
    
*   `quoteItem` (_array of object_) A list of quote items (QuoteItem \[1..\*\]). An item of the quote - it is used to describe an operation on a product to be quoted.
    
    Includes all fields of `quoteItem`.
    
*   `quoteTotalPrice` (_array of object_, required) A list of quote prices (QuotePrice \[\*\]). Quote total price.
    
    Includes all fields of `quotePriceRef`.
    
*   `relatedParty` (_array of object_) A list of related parties (RelatedParty \[\*\]). A reference to a party playing a role in this quote (customer, seller, requester, etc.).
    
    Includes all fields of `relatedPartyRef`.
    

### agreementRef

*   `id` (_string_, required) A string. Unique identifier of a related entity.
*   `href` (_string_) A string. Reference of the related entity.
*   `name` (_string_) A string. Name of the agreement.

### billingAccount

*   `id` (_string_, required) A string. Unique identifier of a related entity.
*   `name` (_string_) A string. Name of the billing account.
*   `href` (_string_) A string. Reference of the billing account.

### contactMedium

*   `characteristic` (_object_) A medium characteristic (MediumCharacteristic). Any additional characteristic(s) of this contact medium.
    
    Includes all fields of `MediumCharacteristicRef`.
    
*   `mediumType` (_string_, required) String that defines the Contact Medium Type. Supported values are Email, Phone and Fax

### quoteItem

*   `id` (_string_) A string. Unique identifier - attributed by quoting system.
*   `href` (_string_) A string. Hyperlink to access the quote.
*   `action` (_string_, required) A string. Action to be performed on this quote item (add, modify, remove, etc.).
*   `product` (_object_) A product ref or value (ProductRefOrValue). A product to be created defined by value or existing defined by reference. The polymorphic attributes @type, @schemaLocation & @referredType are related to the product entity and not the RelatedProductRefOrValue class itself.
    
    Includes all fields of `Product`.
    
*   `productOffering` (_array of object_, required) A product offering reference (ProductOfferingRef). A product offering represents entities that are orderable from the provider of the catalog, this resource includes pricing information.
    
    Includes all fields of `ProductOfferingRef`.
    
*   `quantity` (_integer_) An integer. Quantity asked for this quote item.
*   `quoteItemPrice` (_object_) A list of quote prices (QuotePrice \[\*\]). Price for this quote item.
    
    Includes all fields of `quotePriceRef`.
    
*   `quoteItemRelationship` (_object_) A list of quote item relationships (QuoteItemRelationship \[\*\]). A relationship from item within a quote.
    
    Includes all fields of `quoteItemRelationship`.
    
*   `relatedParty` (_array of object_) A list of related parties (RelatedParty \[\*\]). A reference to a party playing a role in this quote item.
    
    Includes all fields of `relatedPartyRef`.
    
*   `state` (_string_) A string. State of the quote item described in the state machine diagram.

### quotePriceRef

*   `price` (_object_) A price (Price). Provides all amounts (tax included, duty free, tax rate), used currency and percentage to apply for Price Alteration.
    
    Includes all fields of `price`.
    
*   `priceAlteration` (_object_) A list of price alterations (PriceAlteration \[\*\]). Is an amount, usually of money, that modifies the price charged for an order item.
    
    Includes all fields of `priceAlterationRef`.
    
*   `priceType` (_string_) A string. indicate if the price is for recurrent or no-recurrent charge.
*   `productOfferingPrice` (_object_) A product offering price reference (ProductOfferingPriceRef). An amount, usually of money, that is asked for or allowed when a ProductOffering is bought, rented, or leased. The price is valid for a defined period of time.
    
    Includes all fields of `ProductOfferingRef`.
    
*   `recurringChargePeriod` (_string_) A string. Used for recurring charge to indicate period (month, week, etc..).

### relatedPartyRef

*   `id` (_string_, required) A string. Unique identifier of a related entity.
*   `href` (_string_) A string. Reference of the related entity.
*   `name` (_string_) A string. Name of the agreement.
*   `role` (_string_) A string. Role played by the related party.
*   `@referredType` (_string_, required) A string. The actual type of the target instance when needed for disambiguation.

### MediumCharacteristicRef

*   `contactType` (_string_) A string. The type of contact, for example- phone number such as mobile, fixed home, fixed office. postal address such as shipping installation etc.,
*   `emailAddress` (_string_) A string. Full email address in standard format.
*   `faxNumber` (_string_) A string. The fax number of the contact.
*   `phoneNumber` (_string_) A string. The primary phone number of the contact.

### Product

*   `description` (_string_) A string. Is the description of the product. It could be copied from the description of the Product Offering.
*   `orderDate` (_datetime_) A date time (DateTime). Is the date when the product was ordered.
*   `productSerialNumber` (_string_) A string. Is the serial number for the product. This is typically applicable to tangible products e.g. Broadband Router.
*   `productCharacteristic` (_array of object_) A list of characteristics (Characteristic \[\*\]). Describes a given characteristic of an object or entity through a name/value pair.
    
    Includes all fields of `productCharacteristicRef`.
    
*   `productOffering` (_object_) A product offering reference (ProductOfferingRef). A product offering represents entities that are orderable from the provider of the catalog, this resource includes pricing information.
    
    Includes all fields of `ProductOfferingRef`.
    
*   `productSpecification` (_object_) A product specification reference (ProductSpecificationRef). A ProductSpecification is a detailed description of a tangible or intangible object made available externally in the form of a ProductOffering to customers or other parties playing a party role.
    
    Includes all fields of `ProductSpecificationRef`.
    
*   `relatedParty` (_object_) A list of related parties (RelatedParty \[\*\]). Related Entity reference. A related party defines party or party role linked to a specific entity.
    
    Includes all fields of `relatedPartyRef`.
    
*   `status` (_string_) A product status type (ProductStatusType). Is the lifecycle status of the product.
*   `isBundle` (_boolean_) A boolean. If true, the product is a ProductBundle which is an instantiation of a BundledProductOffering. If false, the product is a ProductComponent which is an instantiation of a SimpleProductOffering.
*   `name` (_string_) A string. Name of the product. It could be the same as the name of the product offering.

### ProductOfferingRef

*   `id` (_string_, required) A string. Unique identifier of a related entity.
*   `href` (_string_) A string. Reference of the related entity.
*   `name` (_string_) A string. Name of the related entity.
*   `@type` (_string_) The @type attribute provides a way to represent the actual class type of an entity.

### quoteItemRelationship

*   `id` (_string_, required) A string. ID of the related order item (must be in the same quote).
*   `relationshipType` (_string_, required) A string. Relationship type as relies on, bundles, etc...

### price

*   `taxIncludedAmount` (_object_) A money (Money). All taxes included amount (expressed in the given currency).
    
    Includes all fields of `AmountRef`.
    
*   `percentage` (_integer_) A float. Percentage of discount.

### priceAlterationRef

*   `description` (_string_) A string. A narrative that explains in detail the semantics of this order item price alteration.
*   `name` (_string_) A string. Name of the order item price alteration.
*   `price` (_object_) A price (Price). Provides all amounts (tax included, duty free, tax rate), used currency and percentage to apply for Price Alteration.
    
    Includes all fields of `price`.
    
*   `priceType` (_string_) A string. A category that describes the price such as recurring and one time.
*   `recurringChargePeriod` (_string_) A string. Could be month, week...

### productCharacteristicRef

*   `name` (_string_, required) A string, name of the product characteristic
*   `value` (_string_, required) A string, value of the product characteristic

### ProductSpecificationRef

*   `id` (_string_, required) A string. Unique identifier of a related entity.
*   `href` (_string_) A string. Reference of the related entity.
*   `name` (_string_) A string. Name of the related entity.

### AmountRef

*   `unit` (_string_, required) A money (Money). All taxes excluded amount (expressed in the given currency).
*   `value` (_integer_, required) A float. Percentage to apply for ProdOfferPriceAlteration.